/* Bibliothèque GEM pour X-Windows
   (C) 1998, Emmanuel CURIS - Création : 2 juin 1998

   Fichier d'inclusion générique : tout ce qu'il faut pour utiliser la lib X
*/

#ifndef BIBLIOTHEQUE_X_
# define BIBLIOTHEQUE_X_ /* Pas d'inclusion multiple */

#ifndef e_CIRC /* On n'a pas défini les accents */
# ifdef _latin1_  /* Par défaut : codage ISO-Latin 8859-1 */
#  define ISO_8859_1 1
#  include "latin_1.h"
# endif
# ifdef _utf8_  /* Par défaut : codage UTF-8 */
#  include "utf8.h"
# endif
#endif

typedef int boolean;

#define FAUX       0
#define VRAI       1

/* Inclusion des fichiers X-Window */

#include <X11/X.h>
#include <X11/Xos.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <X11/keysym.h>
#include <X11/Xatom.h>
#include <X11/Xmd.h>

#if defined(AVEC_OPEN_GL_)
# include <GL/glx.h>
#endif

/* Pour ne pas avoir de problème... */
#define USR_FONCTION     PARMBLK
#define CONVERT_PARMBLK 

#if defined(_MIPS_) && defined(_POSIX_SOURCE)
extern char *strdup(const char *chaine); /* strdup pas déclarée si source Posix sous Irix...
					    Mais besoin du posix pour lgamma */
#endif

/* Inclusion des fichiers de la bibliothèque X */

#include "X_arbres.h"
#include "X_clavier.h"
#include "X_dessin.h"
#include "X_fenetres.h"
#include "X_fichiers.h"
#include "X_manquant.h"
#include "X_menu.h"
#include "X_objets.h"
#include "X_ressources.h"
#include "X_tos.h"
#include "X_vdi.h"

#include "X_general.h" /* À la fin car fait appel à tout... */
#include "X_var.h"

/* Fichiers de déclaration : fonctions AES */

#include "X_evnt_lib.h"
#include "X_form_lib.h"
#include "X_graf_lib.h"
#include "X_menu_lib.h"
#include "X_objc_lib.h"
#include "X_rsrc_lib.h"
#include "X_wind_lib.h"

/* Fonctions VDI */

#include "X_v_lib.h"
#include "X_vs_lib.h"
#include "X_vq_lib.h"
#include "X_vdivers_lib.h"

/* Comment faire un bip ? */

#define BI_Bip() XBell( BI_Display, 100 )

#endif /* BIBLIOTHEQUE_X_ */
