/* Bibliothque X-Window pour les interfaces
   Tout ce qui se rapporte aux dessins (dans les fentres, en mmoire,...)
   Fichier  inclure
   (C) 1998-2201, Emmanuel CURIS

 26 mars 1998
   * Cration du fichier
*/

#ifndef X_DESSIN_H_

#define X_DESSIN_H_ /* Protection contre l'inclusion multiple */

struct fenetre;			/* Dfinie dans X_fenetres.h */

typedef XPoint Point_Ecran;	/* Point du plan : cohrence avec les dfinitions X */

/* ~~~~~~~~ Fonctions de contrle des paramtres de trac ~~~~~~~~ */

#define BLANC         0
#define NOIR          1
#define ROUGE         2
#define VERT          3
#define BLEU          4
#define CYAN          5
#define JAUNE         6
#define VIOLET        7
#define GRIS          8 
#define GRIS_FONCE    9
#define ROUGE_FONCE  10
#define VERT_FONCE   11
#define BLEU_FONCE   12
#define CYAN_FONCE   13
#define JAUNE_FONCE  14
#define VIOLET_FONCE 15
#define COULEUR_SPECIALE 16 /* Pour avoir plus de libert sur les couleurs */

#define BI_NOMBRE_COULEURS 16	/* La couleur spciale n'est pas utilise ! */

void X_TRC_Couleur         (unsigned int couleur);

#define BI_DEGRADE_FAUSSES_COULEURS 0 /* En fausses couleurs */
#define BI_DEGRADE_GRIS             1 /* En niveaux de gris */
#define BI_DEGRADE_ROUGE            2 /* En niveaux de rouge */
#define BI_DEGRADE_VERT             3
#define BI_DEGRADE_BLEU             4
#define BI_DEGRADE_CYAN             5
#define BI_DEGRADE_JAUNE            6
#define BI_DEGRADE_MAGENTA          7

#define BI_NOMBRE_DEGRADES 8	/* 8 possibilits de dgrads */

int  X_TRC_CreerDegrade    (struct fenetre *fenetre, unsigned int base);
void X_TRC_CouleurDegrade  (unsigned int base, unsigned int niveau);
void X_TRC_LibererDegrade  (unsigned int base);

void X_TRC_EpaisseurLigne  (unsigned int epaisseur);

#define BI_MODE_REMPLACE    1
#define BI_MODE_TRANSPARENT 2
#define BI_MODE_INVERSE     3
#define BI_MODE_EFFACE      4

void X_TRC_ModeEcriture    (unsigned int mode );
void X_TRC_MotifRemplissage(unsigned int motif);

#define BI_AUCUNE_LIGNE  0
#define BI_CONTINU       1
#define BI_TIRET_LONG    2
#define BI_POINTS        3
#define BI_TIRET_POINT   4
#define BI_TIRET_COURT   5
#define BI_TIRET_2POINTS 6

#define BI_NOMBRE_STYLES_LIGNES 6

void X_TRC_StyleLigne      (unsigned int style);

#ifdef _LIBRAIRIE_X_		/* Fonctions invisibles  l'utilisateur */
int  BIX_InstallerPointilles(GC contexte, unsigned int style);
#endif

/* ~~~~~~~~ Fonctions de base, sans contrle ~~~~~~~~ */

inline void X_TRC_Point(struct fenetre *fenetre, int x, int y);

#define BI_MARQUE_AUCUNE     0
#define BI_MARQUE_POINT      1 	/* Un simple point */
#define BI_MARQUE_PLUS       2	/* Un + */
#define BI_MARQUE_ASTERISQUE 3	/* Un * */
#define BI_MARQUE_CARRE      4	/* Un carr, creux */
#define BI_MARQUE_CROIX      5	/* Un  */
#define BI_MARQUE_LOSANGE    6	/* Un losange */
#define BI_MARQUE_CERCLE     7	/* Un cercle, creux */
#define BI_MARQUE_DISQUE     8	/* Un disque, plein */
#define BI_MARQUE_TRIANGLE_H 9	/* Un triangle quilatral, creux, pointe en haut */
#define BI_MARQUE_TRIANGLE_V 10	/* Un triangle quilatral, creux, pointe en bas */

#define BI_NOMBRE_MARQUES 11

void X_TRC_Marque(struct fenetre *fenetre, int x, int y, unsigned int marque, unsigned int taille);

inline void X_TRC_Ligne      (struct fenetre *fenetre, int x0, int y0, int x1, int y1);
inline void X_TRC_LigneBrisee(struct fenetre *fenetre, unsigned long nombre, Point_Ecran *points);

#define BI_NOMBRE_MAXIMAL_POINTS 100 /* Pas de vraie limite, mais plus risque de consommer de la mmoire pour rien ! */

inline void X_TRC_Triangle     (struct fenetre *fenetre, int x0, int y0, int x1, int y1, int x2, int y2);
inline void X_TRC_TrianglePlein(struct fenetre *fenetre, int x0, int y0, int x1, int y1, int x2, int y2);

inline void X_TRC_Rectangle     (struct fenetre *fenetre, int x_HG, int y_HG, unsigned int largeur, unsigned int hauteur);
inline void X_TRC_RectanglePlein(struct fenetre *fenetre, int x_HG, int y_HG, unsigned int largeur, unsigned int hauteur);

inline void X_TRC_ArcEllipse(struct fenetre *fenetre, int x, int y, unsigned int rayon_H, unsigned int rayon_V, int angle_debut, int angle_fin);

/* X-Window : de toute faon, il faut indiquer les angles => inutile de distinguer les deux fonctions !
              de toute faon, c'est la mme fonction pour un cercle et une ellipse => inutile de distinguer les deux fonctions ! */

#define X_TRC_ArcCercle(f,x,y,r,ad,af) X_TRC_ArcEllipse((f),(x),(y),(r),(r),(ad),(af))
#define X_TRC_Cercle(f,x,y,r)          X_TRC_ArcEllipse((f),(x),(y),(r),(r),0,360)
#define X_TRC_Ellipse(f,x,y,rh,rv)     X_TRC_ArcEllipse((f),(x),(y),(rh),(rv),0,360)

inline void X_TRC_Disque (struct fenetre *fenetre, int x, int y, unsigned int rayon);

#define BI_TEXTE_FER_A_DROITE  0
#define BI_TEXTE_FER_A_GAUCHE  1
#define BI_TEXTE_CENTRER_H     2
#define BI_TEXTE_JUSTIFIER    12

#define BI_TEXTE_FER_EN_HAUT  20
#define BI_TEXTE_CENTRER_V    21
#define BI_TEXTE_LIGNE_BASE   22
#define BI_TEXTE_FER_EN_BAS   23

void X_TRC_Texte(struct fenetre *fenetre, int x, int y, unsigned int mode_H, unsigned int mode_V, unsigned int angle, const char *texte);

#ifdef _LIBRAIRIE_X_		/* Fonctions invisibles  l'utilisateur */
void BIX_TracerMarque(Drawable fenetreX, GC contexte, int x, int y, unsigned int marque, unsigned int taille);
#endif

/* ~~~~~~~~ Fonctions de base, avec contrle [zone de dessin 2D indique] ~~~~~~~~ */

void X_TRC_Z_Point (struct fenetre *fenetre, int x_HG_clip, int y_HG_clip, unsigned int larg_clip, unsigned int haut_clip, int x, int y);
void X_TRC_Z_Marque(struct fenetre *fenetre, int x_HG_clip, int y_HG_clip, unsigned int larg_clip, unsigned int haut_clip,
		    int x, int y, unsigned int marque, unsigned int taille);

void X_TRC_Z_Ligne(struct fenetre *fenetre, int x_HG_clip, int y_HG_clip, unsigned int larg_clip, unsigned int haut_clip,
		   int x0, int y0, int x1, int y1);

void X_TRC_Z_Triangle     (struct fenetre *fenetre, int x_HG_clip, int y_HG_clip, unsigned int larg_clip, unsigned int haut_clip,
			   int x0, int y0, int x1, int y1, int x2, int y2);
void X_TRC_Z_TrianglePlein(struct fenetre *fenetre, int x_HG_clip, int y_HG_clip, unsigned int larg_clip, unsigned int haut_clip,
			   int x0, int y0, int x1, int y1, int x2, int y2);

void X_TRC_Z_Rectangle     (struct fenetre *fenetre, int x_HG_clip, int y_HG_clip, unsigned int larg_clip, unsigned int haut_clip,
			    int x_HG, int y_HG, unsigned int largeur, unsigned int hauteur);
void X_TRC_Z_RectanglePlein(struct fenetre *fenetre, int x_HG_clip, int y_HG_clip, unsigned int larg_clip, unsigned int haut_clip,
			    int x_HG, int y_HG, unsigned int largeur, unsigned int hauteur);

void X_TRC_Z_Cercle (struct fenetre *fenetre, int x_HG_clip, int y_HG_clip, unsigned int larg_clip, unsigned int haut_clip, int x, int y, unsigned int rayon);
void X_TRC_Z_Disque (struct fenetre *fenetre, int x_HG_clip, int y_HG_clip, unsigned int larg_clip, unsigned int haut_clip,
		     int x, int y, unsigned int rayon);
void X_TRC_Z_Ellipse(struct fenetre *fenetre, int x_HG_clip, int y_HG_clip, unsigned int larg_clip, unsigned int haut_clip,
		     int x, int y, unsigned int rayon_H, unsigned int rayon_V);

void X_TRC_Z_Texte(struct fenetre *fenetre, int x_HG_clip, int y_HG_clip, unsigned int larg_clip, unsigned int haut_clip,
		   int x, int y, unsigned int mode_H, unsigned int mode_V, unsigned int angle, const char *texte);

#endif /* X_DESSIN_H_ */
