/* Bibliothque GEM pour X-Windows
   (C) 1998, Emmanuel CURIS
   Dernire modification : 30 octobre 1998

   Bibliothque de diverses choses (GRAF lib)

   30 octobre 1998
     * Corrig X_ascenseur : ne peut renvoyer que des valeurs comprises entre 0 et 1000
*/

#define _LIBRAIRIE_X_

#include <stdio.h>
#include <stdlib.h>

#include "Bib_X.h"

int graf_rubberbox(int xorigin, int yorigin, int wmin, int hmin, int *pwend, int *phend)
{
  printf(" FAIRE : graf_rubberbox(%d, %d, %d, %d %p, %p)\n",
	 xorigin, yorigin, wmin, hmin, (void *) pwend, (void *) phend);
  return -1;
}

int graf_dragbox(int w, int h, int sx, int sy, int xc, int yc, int wc, int hc, int *pdx, int *pdy)
{
  printf(" FAIRE : graf_dragbox(%d, %d, %d, %d, %d, %d, %d, %d, %p, %p)\n",
	 w, h, sx, sy, xc, yc, wc, hc, (void *) pdx, (void *) pdy);
  return -1;
}

int graf_mbox(int w, int h, int srcx, int srcy, int dstx, int dsty)
{
  printf(" FAIRE : graf_mbox(w = %d, h = %d, srcx = %d, srcsy = %d, dstx = %d, dsty = %d)\n",
	 w, h, srcx, srcy, dstx, dsty);
  return -1;
}

#ifdef GRAF_LIB_COMPLETE_
void graf_growbox  (int stx, int sty, int stw, int sth, int finx, int finy, int finw, int finh);
void graf_shrinkbox(int finx, int finy, int finw, int finh, int stx, int sty, int stw, int sth);
int  graf_watchbox (OBJECT *tree, unsigned int obj, int instate, int outstate);
#endif

/* Dplacer un objet dans un autre */

int graf_slidebox(OBJECT *adresse, unsigned int pere, unsigned int objet, int sens)
{
  Arbre *arbre;
  Window f_pere, f_fils;

  if (adresse == NULL)
    return -1;

  arbre = quel_arbre(adresse);
  if (NULL == arbre) {
    (void) fprintf(stderr, "graf_slidebox : arbre inexistant [%p]\n", (void *) adresse);
    return -2;
  }

  if (arbre->drapeaux.ouvert == FAUX) {
    (void) fprintf(stderr, "graf_slidebox : arbre non ouvert\n");
    return -4;
  }

  if ( ( pere >= arbre->nbr_objets) || (objet >= arbre->nbr_objets) ) {
    (void) fprintf(stderr, "graf_slidebox : objet(s) inexistant(s)\n");
    return -3;
  }

  f_pere = (arbre->objets)[pere];
  f_fils = (arbre->objets)[objet];

  return X_ascenseur(f_pere, f_fils, sens);
}

/* --------------- Ralisation effective de graf_slidebox : fentre X dans fentre X ------------\
 |   Renvoie la position de la fentre en pour milles dans la direction demande                 |
 |
 | mere  : la fentre X servant de fond
 | fille : la fentre X fille, que l'on dplace
 | sens  : VERTICAL ou HORIZONTAL
 \---------------------------------------------------------------------------------------------- */

int X_ascenseur(Window mere, Window fille, boolean sens)
{
  int x_fille, y_fille, x_mere, y_mere, j;
  unsigned int haut_fille, larg_fille, larg_mere, haut_mere, i;
  Window racine;
  XEvent evenement;
  long masque = ButtonReleaseMask | PointerMotionMask; /* Dplacement ou fin de clic seulement */
  int x_souris, y_souris;

  XGetGeometry(BI_Display, fille, &racine, &x_fille, &y_fille, &larg_fille, &haut_fille, &i, &i);
  XGetGeometry(BI_Display, mere, &racine, &x_mere, &y_mere, &larg_mere, &haut_mere, &i, &i);

  if ( (larg_mere == larg_fille) && (sens == HORIZONTAL) )
    return 0;
  if ( (haut_mere == haut_fille) && (sens == VERTICAL) )
    return 0;

  XQueryPointer(BI_Display, mere, &racine, &racine, &j, &j, &x_souris, &y_souris, &i);

/* #ifndef _DEVELOPPE_ *//* Version de dveloppement : on ne monopolise pas le pointeur
		       sinon, si plante pendant ce temps, souris bloque -> serveur X bloqu ! */

  if ( XGrabPointer(BI_Display, mere, False, masque, GrabModeAsync, GrabModeAsync, mere,
		    None, CurrentTime) == GrabSuccess ) /* On a pu rserver la souris */
  {
/* #endif *//* _DEVELOPPE_ */
    do {
      XMaskEvent(BI_Display, masque, &evenement);

      if (evenement.xany.window != mere)
	printf("Pas la bonne fentre !\n");

      if ( evenement.type == MotionNotify ) /* Souris dplace */
      {
	if (sens == VERTICAL) {
	  y_fille += (evenement.xmotion.y - y_souris);
	  if (y_fille < 0)
	    y_fille = 0;
	  if (y_fille + haut_fille >= haut_mere)
	    y_fille = haut_mere - haut_fille; 
	  y_souris = evenement.xmotion.y;
	} else {
	  x_fille += (evenement.xmotion.x - x_souris);
	  if (x_fille < 0)
	    x_fille = 0;
	  if (x_fille + larg_fille > larg_mere)
	    x_fille = larg_mere - larg_fille;
	  x_souris = evenement.xmotion.x;
	}

	XMoveWindow(BI_Display, fille, x_fille, y_fille);
      }
    }
    while ( evenement.type != ButtonRelease );

/* #ifndef _DEVELOPPE_ */

    XUngrabPointer(BI_Display, CurrentTime); /* On libre la souris */
    /*    XPutBackEvent(BI_Display, &evenement);*/ /* On rappelle que l'on a relach */
  }

/* #endif*/ /* _DEVELOPPE_ */

  if (sens == VERTICAL) {
    float pos;

    pos = (float) y_fille / ( (float) (haut_mere - haut_fille) );
    if (pos < 0)
      pos = 0; /* Pour tre tranquille */
    if (pos > 1)
      pos = 1; /* Mme remarque */
    return (int) (pos * 1000.0);
  } else {
    float pos;

    pos = (float) x_fille / ( (float) (larg_mere - larg_fille) );
    if (pos < 0)   pos = 0.0;
    if (pos > 1.0) pos = 1.0;
    return (int) (pos * 1000.0);
  }
}

#ifdef GRAF_LIB_COMPLETE_
int  graf_handle   (int *pwchar, int *phchar, int *pwbox, int *phbox);

int graf_mouse(int m_number, MFORM *m_addr)
{
  switch (m_number)
  {
  case M_OFF: /* Curseur visible / invisible : sans intrt sous X... */
  case M_ON:
    return m_number;

  }

  return m_number;
}
#endif

void graf_mkstate(int *pmx, int *pmy, int *pmstate, int *pkstate)
{
  Window racine, mere;
  unsigned int masque;
  int x, y, j;

  /* On rcupre les coordonnes de la souris par rapport  la fentre mre.
     Par hypothse, on utilise la fentre "active" (pour les redessins), car
     c'est probablement celle qui intresse l'utilisateur.
     Les coordonnes obtenus sont relatives  la racine, de toute faon. tant que l'on travaille avec un seul cran,
     a ne devrait pas poser de problme - mais quel programme atari supporte plusieurs crans... */
  mere = BI_Fen_redessin;
  XQueryPointer(BI_Display, mere, &racine, &racine, &j, &j, &x, &y, &masque);

  if (pmx != NULL) *pmx = x;
  if (pmy != NULL) *pmy = y;
  if (pmstate != NULL) *pmstate = (int) masque;
  if (pkstate != NULL) *pkstate = BI_etat; /* Des touches spciales */
}
