/* Bibliothque X-Window pour les interfaces
            Routines associes  la souris
   (C) 1998-1999, Emmanuel CURIS
   Cration le 25 juin 1999
*/

#define _LIBRAIRIE_X_ 

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "bib_interface.h"

/* ~~~~~~~~ Variables locales ~~~~~~~~ */

/* ~~~~~~~~ Fonctions locales ~~~~~~~~ */

/* ~~~~~~~~ Ralisation pratique ~~~~~ */

/* ~-~-~-~-~-~-~-~- tat de la souris ~-~-~-~-~-~-~-~- */

/* -------- tat de toutes les informations souris --------\
 | x, y    : coordonnes au moment du clic                 |
 | boutons : boutons enfoncs                              |
 | n_clics : nombre de clics                               |
 | etat    : tat des touches spciales au moment du clic  |
 \-------------------------------------------------------- */

void BI_EtatSouris(int *x, int *y, int *boutons, unsigned int *n_clics, int *etat)
{
  if ( x != NULL ) {
  }
  if ( y != NULL ) {
  }
  if ( boutons != NULL ) {
    *boutons = BI_bouton;
  }
  if ( n_clics != NULL ) {
  }
  if ( etat != NULL ) {
    *etat = BI_etat;
  }
}

/* -------- Attente d'un clic de la souris --------
 |   Renvoie le bouton utilis pour cliquer
 |
 | Cette fonction attend que l'on clique sur la fentre indique
 | Les autres clics sont ignors ; le clavier est ignor (PERDU)
 | Aucune gestion du double clic par souci de simplicit
 |
 | fenetre = la fentre sur laquelle on doit cliquer
 | mode    = comment surveiller ? Masque de bits, ac_bloquer_souris = on empche la souris de sortir
 | pointeur = fonction  appeler en cas de dplacement de la souris [mme convention que fenetre->rect]
 | x, y    = coordonnes de la souris lors du clic [NULL = ne nous intresse pas]
 | etat    = tat des touches spciales au moment du clic
 \-------------------------------------------------------- */

int BI_AttendClic(Fenetre *fenetre, int mode,
		  void (*pointeur)(Fenetre *fenetre, int x, int y, int vx, int vy),
		  int *x, int *y, int *etat)
{
  int bouton = 0, x_clic = -1, y_clic = -1;
  boolean sortie = FAUX;
  XEvent evenement;
  Window vx_fenetre = None;
  Fenetre *fen_evenement = NULL;

  if (fenetre == NULL) return 0;

#ifdef _DEVELOPPE_
  printf("attend_clic : mode = %d\n", mode);
#endif

  if (pointeur != ( void (*)(Fenetre *, int, int, int, int) ) NULL) {
    if ( (fenetre->rect) ) { /* On enlve l'ancien pointeur */
      (fenetre->rect)(fenetre, -1, -1, fenetre->vx_x, fenetre->vx_y);
    }

    pointeur(fenetre, fenetre->vx_x, fenetre->vx_y, -1, -1); /* On met le nouveau */
  }

  do {
    XNextEvent(BI_Display, &evenement);

    BI_Fen_redessin = evenement.xany.window; /* Fentre concerne -> pour les redessins, ok... */
    if (BI_Fen_redessin != vx_fenetre) {
      vx_fenetre = BI_Fen_redessin;
      fen_evenement = BIX_QuelleFenetre( BI_Fen_redessin );
    }

    switch (evenement.type)
    {
    case ButtonRelease: /* Sans intrt */
      break;

    case ButtonPress: /* Intressant = signale la sortie ! */
      BIBX_verifie_modificateurs(evenement.xbutton.state);
      if (fen_evenement == fenetre) { /* On est sur la bonne fentre */
	sortie = VRAI;
	x_clic = evenement.xbutton.x - fenetre->w_x;
	y_clic = evenement.xbutton.y - fenetre->w_y;
	if (evenement.xbutton.button == Button1)
	  bouton = 1;
	else if (evenement.xbutton.button == Button2) {
	  if ( BI_2_egale_3 == VRAI ) /* On change boutons 2 & 3 */
	    bouton = 4;
	  else
	    bouton = 2;
	} else if ( evenement.xbutton.button == Button3 )	{
	  if ( BI_2_egale_3 == VRAI )
	    bouton = 2;
	  else
	    bouton = 4; /* Attention, un vrai 3e bouton n'existe que sous X !
			   Convention GEM : 1 bit par bouton, donc bit 3 mis <=> 3e bouton mis */
	}
#ifdef _DEVELOPPE_
	else
	  printf("Bouton non gr : %d\n", evenement.xbutton.button);
#endif
      }
      break;

    case KeyPress: /* Il faudrait voir juste pour les touches spciales */
    case KeyRelease: /* Surveillance des touches spciales */
      break;

    case ConfigureNotify: /* Changement de taille de la fentre - XConfigureEvent */
      if (fen_evenement) { /* Il y a une fentre classique associe */
      	int delta_x, delta_y, d_x, d_y;

	delta_x = evenement.xconfigure.width - fen_evenement->larg;
	delta_y = evenement.xconfigure.height - fen_evenement->haut;
	d_x = evenement.xconfigure.x - fen_evenement->x;
	d_y = evenement.xconfigure.y - fen_evenement->y;
	if ( (delta_x == 0) && (delta_y == 0) )	{
	  if ( (d_x == 0) && (d_y == 0) ) {
	    /*	  printf("Configure Notify, sans changement de taille ni position - (%d, %d)\n",
		  evenement.xconfigure.x, evenement.xconfigure.y); */
	  } else {
	    /*	  printf("Dplacement de la fentre\n"); */
	    fen_evenement->x += d_x;
	    fen_evenement->y += d_y;
	  }
	  return VRAI;
	}

	/* On effectue le changement de taille */	
	change_taille_fenetre(fen_evenement, evenement.xconfigure.width, evenement.xconfigure.height);	  
	fen_evenement->x += d_x;
	fen_evenement->y += d_y;
	
	/* Si fentre demande un message spcial en cas de changement de taille, on le fait */
    	if ( fen_evenement->msg_masque.taille == VRAI )	{
	  Message message;

	  message.type = WM_SIZED;
	  message.fenetre.application = 0;
	  message.fenetre.en_plus = 0;
	  message.fenetre.handle = 0; /*quel_handle(fen_evenement);*/
	  message.fenetre.x = fen_evenement->x;
	  message.fenetre.y = fen_evenement->y;
	  message.fenetre.larg = evenement.xconfigure.width;
	  message.fenetre.haut = evenement.xconfigure.height;
	  (fen_evenement->message)(fen_evenement, &message);
	}
      }
      break;
      
    case Expose: /* On affiche la fentre = redessin  - XExposeEvent */
      EVNT_redessin(fen_evenement, (XExposeEvent *) &evenement );
      break;
      
    case MotionNotify: /* Dplacement du curseur */
      if ( (fen_evenement == fenetre) && (pointeur) ) {
	pointeur( fenetre, evenement.xmotion.x - fenetre->w_x, evenement.xmotion.y - fenetre->w_y, fenetre->vx_x, fenetre->vx_y );
	fenetre->vx_x = evenement.xmotion.x - fenetre->w_x;
	fenetre->vx_y = evenement.xmotion.y - fenetre->w_y;
      } else if ( (fen_evenement != NULL) && (fen_evenement->rect) )
	EVNT_pointeur(fen_evenement, &(evenement.xmotion) );
      break;

    case EnterNotify:  /* Entre dans une fentre */
      if ( (fen_evenement == fenetre) && (pointeur) ) {
	fenetre->vx_x = evenement.xcrossing.x - fenetre->w_x;
	fenetre->vx_y = evenement.xcrossing.y - fenetre->w_y;
	pointeur( fenetre, fenetre->vx_x, fenetre->vx_y, -1, -1 );
      } else {
	EVNT_entree(fen_evenement, &(evenement.xcrossing));
      }
      break;

    case LeaveNotify:  /* Sortie d'une fentre */
      if ( (fen_evenement == fenetre) && (pointeur) ) {
	pointeur(fenetre, -1, -1, fenetre->vx_x, fenetre->vx_y);
	fenetre->vx_x = -1;
	fenetre->vx_y = -1;
      } else {
	EVNT_sortie(fen_evenement, &(evenement.xcrossing));
      }
      break;
    }
  } while (sortie == FAUX);

  /* On a fini : on mmorise tout, donc */
  if (pointeur) /* On coupe donc le pointeur */
    pointeur(fenetre, -1, -1, x_clic, y_clic);
  if (fenetre->rect) { /* Et on met l'ancien, si ncessaire */
    (fenetre->rect)(fenetre, x_clic, y_clic, -1, -1);
    fenetre->vx_x = x_clic;
    fenetre->vx_y = y_clic;
  }

  if (x != NULL) *x = x_clic;
  if (y != NULL) *y = y_clic;
  if (etat != NULL) *etat = BI_etat;

  return bouton;
}

/* -------- Attente du relchement des boutons de la souris --------- *
 | Renvoie VRAI si tout s'est bien pass (toujours le cas...)
 |
 | Cette fonction attend que l'on relache le clic sur la fentre indique
 | Le clavier est ignor (PERDU), les autres boutons aussi
 |
 | fenetre = la fentre sur laquelle on doit cliquer
 | mode    = comment surveiller ? Masque de bits, ac_bloquer_souris = on empche la souris de sortir
 | bouton  = le bouton dont on attend le relachement (masque de bits)
 | pointeur = fonction  appeler en cas de dplacement de la souris [mme convention que fenetre->rect]
 |            (si NULL, on ne suit pas le dplacement de la souris)
 | x, y    = coordonnes de la souris lors du clic [NULL = ne nous intresse pas]
 | etat    = tat des touches spciales au moment du clic
 \-------------------------------------------------------- */

int BI_AttendRelache(Fenetre *fenetre, int mode, int bouton,
		     void (*pointeur)(Fenetre *fenetre, int x, int y, int vx, int vy),
		     int *x, int *y, int *etat)
{
  XEvent evenement;
  Window racine, fille;
  Window vx_fenetre = None;
  Fenetre *fen_evenement = NULL;
  boolean sortie = FAUX;
  int x_clic, y_clic, x_racine, y_racine;
  unsigned int masque;

  if (fenetre == NULL) return FAUX;
  if (bouton == 0) return FAUX; /* Pas de bouton  surveiller... */

#ifdef _DEVELOPPE_
  printf("attend_relache : mode = %d\n", mode);
#endif

  XQueryPointer(BI_Display, DefaultRootWindow(BI_Display), &racine, &fille, &x_racine, &y_racine,
		&x_clic, &y_clic, &masque);
  if (masque == 0) return VRAI; /* On a dj relach */

  if ( pointeur != ( void (*)(Fenetre *, int, int, int, int) ) NULL ) {
    if ( (fenetre->rect) ) { /* On enlve l'ancien pointeur */
      (fenetre->rect)(fenetre, -1, -1, fenetre->vx_x, fenetre->vx_y);
    }

    pointeur(fenetre, fenetre->vx_x, fenetre->vx_y, -1, -1); /* On met le nouveau */
  }

  do {
    XNextEvent(BI_Display, &evenement);

    BI_Fen_redessin = evenement.xany.window; /* Fentre concerne -> pour les redessins, ok... */
    if ( BI_Fen_redessin != vx_fenetre ) {
      vx_fenetre = BI_Fen_redessin;
      fen_evenement = BIX_QuelleFenetre(BI_Fen_redessin);
    }

    switch (evenement.type)
    {
    case ButtonPress: /* Sans intrt */
      break;

    case ButtonRelease: /* Intressant = signale la sortie ! */
      BIBX_verifie_modificateurs(evenement.xbutton.state);
      if (fen_evenement == fenetre) /* On est sur la bonne fentre */
      {
	sortie = VRAI;
	x_clic = evenement.xbutton.x - fenetre->w_x;
	y_clic = evenement.xbutton.y - fenetre->w_y;
	if (evenement.xbutton.button == Button1)
	  bouton = 1;
	else if (evenement.xbutton.button == Button2)
	  bouton = 2;
	else if ( evenement.xbutton.button == Button3 )
	{
	  if ( BI_2_egale_3 == VRAI )
	    bouton = 2;
	  else
	    bouton = 4; /* Attention, un vrai 3e bouton n'existe que sous X !
			   Convention GEM : 1 bit par bouton, donc bit 3 mis <=> 3e bouton mis */
	}
#ifdef _DEVELOPPE_
	else
	  printf("Bouton non gr : %d\n", evenement.xbutton.button);
#endif
      }
      break;

    case KeyPress: /* Il faudrait voir juste pour les touches spciales */
    case KeyRelease: /* Surveillance des touches spciales */
      break;

    case ConfigureNotify: /* Changement de taille de la fentre - XConfigureEvent */
      if (fen_evenement) /* Il y a une fentre classique associe */
      {
	int delta_x, delta_y, d_x, d_y;

	delta_x = evenement.xconfigure.width - fen_evenement->larg;
	delta_y = evenement.xconfigure.height - fen_evenement->haut;
	d_x = evenement.xconfigure.x - fen_evenement->x;
	d_y = evenement.xconfigure.y - fen_evenement->y;
	if ( (delta_x == 0) && (delta_y == 0) )
	{
	  if ( (d_x == 0) && (d_y == 0) )
	  {
	    /*	  printf("Configure Notify, sans changement de taille ni position - (%d, %d)\n",
		  evenement.xconfigure.x, evenement.xconfigure.y); */
	  }
	  else
	  {
	    /*	  printf("Dplacement de la fentre\n"); */
	    fen_evenement->x += d_x;
	    fen_evenement->y += d_y;
	  }
	  return VRAI;
	}

	/* On effectue le changement de taille */	
	change_taille_fenetre(fen_evenement, evenement.xconfigure.width, evenement.xconfigure.height);	  
	fen_evenement->x += d_x;
	fen_evenement->y += d_y;
	
	/* Si fentre demande un message spcial en cas de changement de taille, on le fait */
	if ( fen_evenement->msg_masque.taille == VRAI )
	{
	  Message message;

	  message.type = WM_SIZED;
	  message.fenetre.application = 0;
	  message.fenetre.en_plus = 0;
	  message.fenetre.handle = 0; /*quel_handle(fen_evenement);*/
	  message.fenetre.x = fen_evenement->x;
	  message.fenetre.y = fen_evenement->y;
	  message.fenetre.larg = evenement.xconfigure.width;
	  message.fenetre.haut = evenement.xconfigure.height;
	  (fen_evenement->message)(fen_evenement, &message);
	}
      }
      break;
      
    case Expose: /* On affiche la fentre = redessin  - XExposeEvent */
      EVNT_redessin(fen_evenement, (XExposeEvent *) &evenement );
      break;
      
    case MotionNotify: /* Dplacement du curseur */
      if ( (fen_evenement == fenetre) && (pointeur) ) {
	pointeur(fenetre, evenement.xmotion.x - fenetre->w_x, evenement.xmotion.y - fenetre->w_y, fenetre->vx_x, fenetre->vx_y);
	fenetre->vx_x = evenement.xmotion.x - fenetre->w_x;
	fenetre->vx_y = evenement.xmotion.y - fenetre->w_y;
      }
      else if ( (fen_evenement != NULL) && (fen_evenement->rect) )
	EVNT_pointeur(fen_evenement, &(evenement.xmotion) );
      break;

    case EnterNotify:  /* Entre dans une fentre */
#ifdef ancien_
      if ( fen_evenement )
      {
	if ( (fen_evenement->type == GL_TRIPLE_FENETRE) &&
	   (evenement.xcrossing.window == fen_evenement->pointeur_interne.open_gl->handle) )
	{
	  Window fen[2];

	  fen[0] = fen_evenement->pointeur_interne.open_gl->handle;
	  fen[1] = fen_evenement->handle;
	  XSetWMColormapWindows(BI_Display, fen_evenement->handle, fen, 2);
	}
      }
#endif

      if ( (fen_evenement == fenetre) && (pointeur) ) {
	fenetre->vx_x = evenement.xcrossing.x - fenetre->w_x;
	fenetre->vx_y = evenement.xcrossing.y - fenetre->w_y;
	pointeur(fenetre, fenetre->vx_x, fenetre->vx_y, -1, -1);
      } else if ( (fen_evenement != NULL) && (evenement.xcrossing.subwindow == None) ) {
	if ( fen_evenement->rect ) {
	  fen_evenement->vx_x = evenement.xcrossing.x - fenetre->w_x;
	  fen_evenement->vx_y = evenement.xcrossing.y - fenetre->w_y;
	  (fen_evenement->rect)(fen_evenement, fen_evenement->vx_x, fen_evenement->vx_y, -1, -1);
	}
      }
      break;

    case LeaveNotify:  /* Sortie d'une fentre */
#ifdef ancien
      if ( fen_evenement != NULL)
      {
	if ( (fen_evenement->type == GL_TRIPLE_FENETRE) &&
	     (evenement.xcrossing.window == fen_evenement->pointeur_interne.open_gl->handle) )
	{
	  Window fen[2];

	  fen[0] = fen_evenement->handle;
	  fen[1] = fen_evenement->pointeur_interne.open_gl->handle;
	  XSetWMColormapWindows(BI_Display, fen_evenement->handle, fen, 2);
	}
      }
#endif

      if ( (fen_evenement == fenetre) && (pointeur) ) {
	pointeur(fenetre, -1, -1, fenetre->vx_x, fenetre->vx_y);
	fenetre->vx_x = -1;
	fenetre->vx_y = -1;
      } else if ( (fen_evenement != NULL) && (evenement.xcrossing.subwindow == None) ) {
	if ( fen_evenement->rect ) {
	  (fen_evenement->rect)(fen_evenement, -1, -1, fen_evenement->vx_x, fen_evenement->vx_y);
	  fen_evenement->vx_x = -1; fen_evenement->vx_y = -1;
	}
      }
      break;

    }
  } while (sortie == FAUX);

  /* On a fini : on mmorise tout, donc */
  if (pointeur) /* On coupe donc le pointeur */
    pointeur(fenetre, -1, -1, x_clic, y_clic);
  if (fenetre->rect) { /* Et on met l'ancien, si ncessaire */
    (fenetre->rect)(fenetre, x_clic, y_clic, -1, -1);
    fenetre->vx_x = x_clic;
    fenetre->vx_y = y_clic;
  }

  if (x != NULL) *x = x_clic;
  if (y != NULL) *y = y_clic;
  if (etat != NULL) *etat = BI_etat;

  return VRAI;
}

/* ~~~~~~~~~~~~~~~~ Gestion des dplacements du pointeur souris ~~~~~~~ */

/* -------- Entre dans une fentre -------- */

int EVNT_entree(Fenetre *fenetre, XCrossingEvent *evenement)
{
  if ( NULL == fenetre ) {
    OPTION_A_FAIRE("Vrifier que l'on entre dans le menu");
    return BI_EVENEMENT_TRAITE; /* Concerne une autre fentre que le menu : rien de particulier  faire... */
  }

#ifdef ancien_
  if ( BI_OpenGL_actif == VRAI ) { /* OpenGL est actif, utilis */
    if ( (fenetre->type == GL_TRIPLE_FENETRE) || (GL_MIXTE_FENETRE == fenetre->type) ) {
      BI_infos_GL *infos_gl = fenetre->pointeur_interne.open_gl;

      if ( (NULL != infos_gl) && (evenement->window == infos_gl->handle) ) {
	Window fen[2];

	fen[0] = infos_gl->handle;
	fen[1] = fenetre->handle;
	XSetWMColormapWindows(BI_Display, fenetre->handle, fen, 2);

	if ( infos_gl->rect ) {
	  Window ex_redessin = BI_Fen_redessin;

	  BI_Fen_redessin = infos_gl->handle;
	  (infos_gl->rect)(fenetre, evenement->x, evenement->y, -1, -1);
	  infos_gl->vx_x = evenement->x; infos_gl->vx_y = evenement->y;
	  BI_Fen_redessin = ex_redessin;
	}
	return BI_EVENEMENT_TRAITE;
      } 
    }
  }
#endif
  if ( evenement->subwindow == None ) {
    if ( fenetre->rect) {
      Window ex_redessin = BI_Fen_redessin;

      BI_Fen_redessin = fenetre->handle;
      fenetre->vx_x = evenement->x - fenetre->w_x;
      fenetre->vx_y = evenement->y - fenetre->w_y;
#ifdef _DEVELOPPE_
      /*	printf("X_gene : on entre dans la fentre %ld\n", evenement.xcrossing.window); */
#endif
      (fenetre->rect)( fenetre, fenetre->vx_x, fenetre->vx_y, -1, -1 );
      BI_Fen_redessin = ex_redessin;
    }
  }

  return BI_EVENEMENT_TRAITE; /* Trait... */
}

/* -------- Dplacement sur une fentre -------- */

int EVNT_pointeur(Fenetre *fenetre, XMotionEvent *pointeur)
{
  if ( NULL == fenetre ) return BI_EVENEMENT_TRAITE;
  if ( None == fenetre->handle ) return BI_EVENEMENT_TRAITE; /* Fentre temporairement ferme... */

#ifdef ancien_
  if ( VRAI == BI_OpenGL_actif ) { /* On est sous Open-GL */
    if ( (fenetre->type == GL_TRIPLE_FENETRE) || ( fenetre->type == GL_MIXTE_FENETRE ) ) {
      if ( fenetre->pointeur_interne.open_gl != NULL ) {
	BI_infos_GL *infos_gl = fenetre->pointeur_interne.open_gl;

	if ( pointeur->window == infos_gl->handle ) { /* On est sur la partie Open-GL de la fentre */
	  if ( infos_gl->rect ) { /* Et on a une routine spciale associe */
	    Window ex_redessin = BI_Fen_redessin;

	    BI_Fen_redessin = infos_gl->handle;
	    (infos_gl->rect)(fenetre, pointeur->x, pointeur->y, infos_gl->vx_x, infos_gl->vx_y);
	    infos_gl->vx_x = pointeur->x;
	    infos_gl->vx_y = pointeur->y;
	    BI_Fen_redessin = ex_redessin;
	  }
	  return BI_EVENEMENT_TRAITE;
	}
      }
    }
  }
#endif

  if ( None == pointeur->subwindow ) { /* N'a pas eu lieu sur une sous-fentre */
    if (fenetre->rect) { /* Fonction spciale associe */
      Window ex_redessin = BI_Fen_redessin;

#ifdef _DEVELOPPE_
      /*      printf("On dplace la souris - "); */
#endif

      /* Les coordonnes sont converties dans l'espace interne de la fentre, ie 0 si fenetre->w_x */
      if ( ( fenetre->vx_x >= 0 ) && ( fenetre->vx_y >= 0 ) ) {
	BI_Fen_redessin = pointeur->window;
	(fenetre->rect)( fenetre, pointeur->x - fenetre->w_x, pointeur->y - fenetre->w_y, fenetre->vx_x, fenetre->vx_y );
	fenetre->vx_x = pointeur->x - fenetre->w_x;
	fenetre->vx_y = pointeur->y - fenetre->w_y;
	BI_Fen_redessin = ex_redessin;
#ifdef _DEVELOPPE_
      } else {
/* printf("EVNT_pointeur : dplacement alors que l'on n'est pas entr dans la fentre : nglig.\n");*/
#endif
      }

      return BI_EVENEMENT_TRAITE; /* Un vnement pointeur est toujours trait ! */
    }
  }

  /* On nglige les dplacements sur les sous-fentres [ascenseurs,...] */
  return BI_EVENEMENT_TRAITE;
}

/* -------- Sortie d'une fentre */

int EVNT_sortie(Fenetre *fenetre, XCrossingEvent *evenement)
{
  if ( NULL == fenetre ) {
    OPTION_A_FAIRE("Vrifier que l'on sort d'un menu");
    return BI_EVENEMENT_TRAITE; /* Concerne une autre fentre que le menu : rien de particulier  faire... */
  }

#ifdef ancien_
  if ( BI_OpenGL_actif == VRAI ) { /* OpenGL est actif, utilis */
    if ( (fenetre->type == GL_TRIPLE_FENETRE) || (GL_MIXTE_FENETRE == fenetre->type) ) {
      BI_infos_GL *infos_gl = fenetre->pointeur_interne.open_gl;
      
      if ( (NULL != infos_gl) && (evenement->window == infos_gl->handle) ) {
	Window fen[2];

	fen[0] = fenetre->handle;
	fen[1] = infos_gl->handle;
	XSetWMColormapWindows(BI_Display, fenetre->handle, fen, 2);

	if ( infos_gl->rect ) {
	  Window ex_redessin = BI_Fen_redessin;

	  BI_Fen_redessin = infos_gl->handle;
	  (infos_gl->rect)(fenetre, -1, -1, evenement->x, evenement->y);
	  infos_gl->vx_x = -1; infos_gl->vx_y = -1;
	  BI_Fen_redessin = ex_redessin;
	}

	return BI_EVENEMENT_TRAITE; /* Pointeur : gr seulement si fonction associe ! */
      }
    }
  }
#endif
  if ( evenement->subwindow == None ) {
    if ( fenetre->rect ) {
      Window ex_redessin = BI_Fen_redessin;

      BI_Fen_redessin = fenetre->handle;
#ifdef _DEVELOPPE_
      /* printf("X_gene : on sort de la fentre %ld\n", evenement.xcrossing.window);*/
#endif
      (fenetre->rect)( fenetre, -1, -1, fenetre->vx_x, fenetre->vx_y );
      fenetre->vx_x = -1; fenetre->vx_y = -1;
      BI_Fen_redessin = ex_redessin;
    }
  }

  return BI_EVENEMENT_TRAITE; /* Autres cas */
}
