/* Bibliothèque X-Window pour les interfaces
            Déclaration des variables globales
	    Compatible avec gem_gene.c (version GEM : référence)
   (C) 1998, Emmanuel CURIS

 25 mars 1998
   * On continue le fichier...

 19 mars 1998
   * Création du fichier
   * Récupéré les initialisations dans x_win_gem.c (vieux truc...)
*/

#define _LIBRAIRIE_X_

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "Bib_X.h"

/* ------------- Spécifiques à X-Windows --------------- */

boolean BI_2_egale_3       = FAUX; /* VRAI <=> boutons 2 et 3 ont le même rôle */
boolean BI_synchronisation = FAUX; /* VRAI <=> on passe en mode X synchrone    */
boolean BI_OpenGL_actif    = FAUX; /* VRAI si on arrive à activer Open-GL */
boolean BI_GL_direct       = VRAI; /* VRAI : affichage Open-GL direct dans la fenêtre (rapide, clignote)
				      FAUX : affichage dans un Pixmap (plus lent, clignote pas) */
boolean BI_Freedesktop_OK  = FAUX; /* VRAI : supporte le protocole freedesktop [type KDE/Gnome] => propriétés plus riches ! */

Atom BI_ProtocoleFermerFenetre = None; /* Pour fermeture par le gestionnaire de fenêtres */
Atom _NET_ACTIVE_WINDOW = None;	/* Les propriétés pour EWMH v. 1.3 */

Colormap  BI_Palette; /* La palette de couleurs ? */
Display  *BI_Display; /* Paramètres d'affichage   */
GC        BI_GC_programme; /* Environnement graphique général */
GC        BI_GC_objets;    /* Environnement graphique pour le dessin des ressources */

int       BI_Num_ecran;    /* Le numéro de l'écran */
Screen   *BI_Ecran;        /* L'écran pour les affichages */
Visual   *BI_Visual;       /* À quoi ça peut bien servir ? */

XIM       BI_Methode_entree;  /* La méthode d'entrée [au « clavier »] des caractères, cf. man XOpenIM */
XIMStyle  BI_Methode_choisie; /* Parmi les méthodes possibles, celle choisie */

Window    BI_Fen_racine;   /* La fenêtre racine pour l'affichage */
Window    BI_Fen_redessin; /* La fenêtre dans laquelle on travaille */

XColor       BI_Couleur;      /* Couleur définie pour X-Window                           */
XColor       BI_Couleurs[17]; /* Les 16 couleurs de base du GEM atari, + une spéciale... */
XFontStruct *BI_Fonte;        /* Fonte utilisée pour les affichages de texte par défaut  */
XFontSet     BI_FonteUTF8 = NULL; /* Idem, mais dans le cas d'affichages UTF-8 [NULL si latin-1 ou autre... */

char *BI_nom_fonte = NULL;  /* Nom de la fonte à utiliser - paramétrable par l'utilisateur */

/* Nom de la fonte par défaut, si aucune n'est fournie par l'utilisateur */

#ifdef utf8
/* Fontes UTF8 disponibles... [linux mageia5 : (14 = taille en pixels)
   -adobe-new century schoolbook-*-*-*-*-14-*-*-*-*-*-iso10646-1
   -adobe-courier-*-*-*-*-14-*-*-*-*-*-iso10646-1
   -adobe-helvetica-*-*-*-*-14-*-*-*-*-*-iso10646-1
   -*-fixed-*-*-*-*-14-*-*-*-*-*-iso10646-1
 */
const char *BI_fonte_defaut = "-*-fixed-*-*-*-*-14-*-*-*-*-*-iso10646-1";
#else
/* Valeurs par défaut possibles : 6x13, fixed */
const char *BI_fonte_defaut = "6x13";
#endif

unsigned int BI_larg_ecran, BI_haut_ecran; /* Dimensions de l'écran utilisable */
unsigned int BI_larg_defaut = 800,
             BI_haut_defaut = 600; /* Dimensions par défaut des fenêtres, en pixels */

unsigned int BI_larg_car = 10, BI_haut_car = 10; /* Dimensions d'un caractère = unité de base des dessins */

XSetWindowAttributes BI_Attributs; /* Attributs de fenêtre*/

Fenetre *BI_Fenetre_alertes; /* Fenêtre pour afficher les messages d'alerte        */
Fenetre *BI_Fenetre_systeme; /* Fenêtre pour afficher pas mal de choses du système */
Fenetre *BI_Fenetre_menu;    /* Fenêtre pour afficher le menu                      */

unsigned int BI_nbr_arbres;  /* Le nombre d'arbres au total dans le programme */

int BI_PRG_menu;       /* Numéro de l'arbre servant de menu (int car -1 : aucun arbre) */
int BI_PRG_arbre;      /* Arbre actif (dans ext_formdo)     */

Arbre *BI_ARB_alertes = NULL; /* Arbre pour les messages d'alerte    */
Arbre *BI_ARB_fselect = NULL; /* Arbre pour le sélecteur de fichiers */

Menu *BI_Menu = NULL; /* Menu */

boolean BI_Serveur_X_bloque = FAUX; /* VRAI si appel sous interruption -> serveur X bloqué */

int BI_x_souris, BI_y_souris;

int BI_double_clic = 100; /* Temps d'attente du double-clic, en ms */

/* -------- Générales du programme --- */

Station_VDI *_PRG_station;

long gdos = FAUX;                         /* Version de GDOS installée : toujours faux sous X... */

int BI_bouton;
int BI_etat;

Arbre *arbres;       /* Adresses des structures d'arbres  */

int buffer[8];       /* Tampon pour les messages */

Fenetre *BI_premiere_fenetre;

OBJECT Boite_d_alerte[] = 
{/* Racine */
  {-1, 1, 9, G_BOX,
   NONE, NORMAL, {(char *) 0x00000100L},
   0, 0, 61, 9},
 /* Première chaîne */
  { 2, -1, -1, G_STRING,
    NONE, NORMAL, {NULL},
    10, 1, 50, 1},
 /* Deuxième chaîne */
  {3, -1, -1, G_STRING,
   NONE, NORMAL, {NULL},
   10, 2, 50, 1},
 /* Troisième chaîne */
  { 4, -1, -1, G_STRING,
    NONE, NORMAL, {NULL},
    10, 3, 50, 1},
 /* Quatrième chaîne */
  { 5, -1, -1, G_STRING,
    NONE, NORMAL, {NULL},
    10, 4, 50, 1},
 /* Cinquième chaîne */
  { 6, -1, -1, G_STRING,
    NONE, NORMAL, {NULL},
    10, 5, 50, 1},
 /* Premier bouton */
  { 7, -1, -1, G_BUTTON,
    EXIT, NORMAL, {"Bouton 1"},
    5, 7, 15, 1},
 /* Deuxième bouton */
  { 8, -1, -1, G_BUTTON,
    EXIT, NORMAL, {"Bouton 2"},
    25, 7, 15, 1},
 /* Troisième bouton */
  { 9, -1, -1, G_BUTTON,
    EXIT, NORMAL, {"Bouton 3"},
    45, 7, 15, 1},
 /* Icône --- Objet 9 */
  { ROOT, -1, -1, G_ICON,
    LASTOB, NORMAL, {NULL},
    1, 1, 8, 5}
};

#ifdef AVEC_OPEN_GL_
XVisualInfo XGL_Visual = { NULL, (VisualID) 0, 0, 0, 0, 0L, 0L, 0L, 0, 0 };
Colormap    XGL_Palette;
boolean     BI_OpenGL_dBuffer;
#endif
