/* Bibliothque GEM pour X-Windows
   (C) 1998, Emmanuel CURIS

   Bibliothque de base VDI (fonctions vs_xxx : installation de paramtres)
*/

#define _LIBRAIRIE_X_

#include <stdio.h>
#include <stdlib.h>

#include "bib_interface.h"

#ifdef AVEC_VDI_COMPLETE_
int  vst_load_fonts    (int handle, int select);
void vst_unload_fonts  (int handle, int select);
int  vst_ex_load_fonts (int handle, int select, int font_max, int font_free);
#endif

void vs_clip(int handle, int clip_flag, int *pxyarray) /* Installer le clipping */
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return;

  if (clip_flag == 1) { /* On installe le clipping */
    XRectangle rectangle;

    rectangle.x      = (short) pxyarray[0];
    rectangle.y      = (short) pxyarray[1];
    rectangle.width  = (unsigned short) pxyarray[2];
    rectangle.height = (unsigned short) pxyarray[3];

    XSetClipRectangles(BI_Display, _PRG_station->gr_contexte, 0, 0,
		       &rectangle, 1, Unsorted);
  } else { /* On coupe le clipping */
    XSetClipMask(BI_Display, _PRG_station->gr_contexte, None); /* Pas de clipping */
  }
}

int vswr_mode(int handle, int mode)
{
  Station_VDI *station;
  XGCValues parametres;

  station = quelle_station(handle);
  if (station == NULL)
    return -1;

  switch (mode)
  {
  case MD_REMPLACE:
    parametres.function = GXcopy;
    break;

  case MD_TRANSPARENT:
    parametres.function = GXor;
    break;

  case MD_INVERSE:
/*     parametres.function = GXinvert; */
    break;

  case MD_EFFACE:
    parametres.function = GXorInverted;
    break;

  default:
    parametres.function = GXset; /* a n'existe pas, ce mode -> n'importe quoi ;-) */
    mode = -1;
  }

  XChangeGC(BI_Display, station->gr_contexte, GCFunction, &parametres);

  return mode;
}

/* -------- On modifie la couleur indique -------- */

void vs_color(int handle, int couleur, int *rgb_in)
{
  Station_VDI *station;
  Status retour;

  if (rgb_in == NULL) return;

  station = quelle_station(handle);
  if (station == NULL) return;

  if (couleur < 0) couleur = COULEUR_SPECIALE;
  if (couleur > 15) couleur = COULEUR_SPECIALE;

  XFreeColors(BI_Display, BI_Palette, &(BI_Couleurs[couleur].pixel), 1, 0);
  BI_Couleurs[couleur].red   = (unsigned short int) (rgb_in[0] * 65535.0/255.0); /* VDI : 0-255, X : 0-65535 */
  BI_Couleurs[couleur].green = (unsigned short int) (rgb_in[1] * 65535.0/255.0);
  BI_Couleurs[couleur].blue  = (unsigned short int) (rgb_in[2] * 65535.0/255.0);
  retour = XAllocColor(BI_Display, BI_Palette, BI_Couleurs + couleur);
  if (retour == FAUX) {
    (void) fprintf(stderr, "vs_color : impossible d'allouer la couleur R = %d, V = %d, B = %d\n", rgb_in[0], rgb_in[1], rgb_in[2]);
    /*  } else { */
    /*    printf("vs_color : couleur r=%d v=%d b=%d allouee\n", rgb_in[0], rgb_in[1], rgb_in[2]); */
  }
}

int vsl_type(int handle, int style) /* Style de ligne */
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return -1;

  if (style < 0) style = 0;

  station->lgn_style = style;

  return style;
}

#ifdef AVEC_VDI_COMPLETE_
void vsl_udsty         (int handle, int pattern);
#endif

int vsl_width(int handle, int epaisseur)
{
  Station_VDI *station;
  XGCValues parametres;

  station = quelle_station(handle);
  if (station == NULL)
    return -1;
  if ( epaisseur < 1 ) epaisseur = 1;

  XGetGCValues(BI_Display, station->gr_contexte, GCLineStyle|GCCapStyle|GCJoinStyle, &parametres);

  XSetLineAttributes(BI_Display, station->gr_contexte, epaisseur, parametres.line_style, 
		     parametres.cap_style, parametres.join_style);
  return epaisseur;
}

int vsl_color(int handle, int couleur)
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return -1;

  if (couleur < 0 ) couleur = 0;
  if (couleur > 15) couleur = COULEUR_SPECIALE;

  station->lgn_couleur = couleur;
  return couleur;
}

#ifdef AVEC_VDI_COMPLETE_
void vsl_ends          (int handle, int beg_style, int end_style);
#endif

int vsm_type(int handle, int symbole)
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return -1;

  station->mk_type = symbole;
  return symbole;
}

int vsm_height(int handle, int hauteur)
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return -1;

  if (hauteur < 1) hauteur = 1;
  station->mk_taille = hauteur;
  return hauteur;
}

int vsm_color(int handle, int couleur)
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return -1;

  if (couleur < 0 ) couleur = 0;
  if (couleur > 15) couleur = COULEUR_SPECIALE;

  station->mk_couleur = couleur;
  return couleur;
}

void vst_height(int handle, int height, int *char_width, int *char_height,
		int *cell_width, int *cell_height)
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return;

#ifdef _DEVELOPPE_
  printf( "vst_height( handle = %d, height = %d, char_width = %p, char_height = %p, cell_width = %p, cell_height = %p )\n",
	  handle, height, (void *) char_width, (void *) char_height, (void *) cell_width, (void *) cell_height );
#endif
}

#ifdef AVEC_VDI_COMPLETE_
int  vst_point(int handle, int point, int *char_width, int *char_height,
	       int *cell_width, int *cell_height);
#endif

int vst_rotation(int handle, int angle)
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return -1;

  while (angle > 3600) /* On passe entre 0 et 360, en utilisant la priode... */
    angle -= 3600;
  while (angle < 0)
    angle += 3600;

  station->txt_angle = angle;
  return angle;
}

int vst_font(int handle, int fonte) /* Installer la fonte */
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return -1;

  return fonte;
}

int vst_color(int handle, int color_index)
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return -1;

  if (color_index < 0)  color_index = 0;
  if (color_index > 15) color_index = COULEUR_SPECIALE;

  station->txt_couleur = color_index;
  return color_index;
}

#ifdef AVEC_VDI_COMPLETE_
int  vst_effects       (int handle, int effect);
#endif

void vst_alignment(int handle, int hor_in, int vert_in, int *hor_out, int *vert_out)
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return;

  station->txt_just = hor_in;
  station->txt_vert = vert_in;

  if ( hor_out != NULL ) *hor_out = hor_in;
  if ( vert_out != NULL ) *vert_out = vert_in;
}

#ifdef AVEC_VDI_COMPLETE_
void vsc_form          (int handle, int *cur_form);
void vsin_mode         (int handle, int dev_type, int mode);
int  vsm_locator       (int handle, int initx, int inity,
                          int *xout, int *yout, int *term);
void vsm_valuator      (int handle, int val_in, int *val_out,
                          int *term, int *status);
int  vsm_choice        (int handle, int *choice);
int  vsm_string        (int handle, int length, int echo_mode,
                          int *echo_xy, char *string);
void vsc_form          (int handle, int *cur_form);
void vs_curaddress     (int handle, int row, int column);
int  vs_palette        (int handle, int palette);
int  vs_mute           (int handle, int action);
void vsp_film          (int handle, int index, int lightness);
void vsc_expose        (int handle, int state);
void vs_bkcolor        (int handle, int color);
void vsp_state         (int handle, int port, int film_num,
                          int lightness, int interlace, int planes, int *indexes);
void vsp_save          (int handle);
void vsp_message       (int handle);
#endif

int vsf_interior(int handle, int style) /* Installer le type de motif de remplissage */
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return -1;

  OPTION_A_FAIRE( "Installer le type de motif de remplissage" );

  return style;
}

int vsf_style(int handle, int style_index) /* Installer le motif de remplissage */
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return -1;

  OPTION_A_FAIRE( "Installer le style de motif de remplissage" );

  return style_index;
}

int vsf_color(int handle, int couleur)
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return -1;

  if (couleur < 0)   couleur = 0;
  if (couleur > 255) couleur = COULEUR_SPECIALE;

  station->fil_couleur = couleur;
  return couleur;
}

int vsf_perimeter(int handle, int per_vis) /* Bord visible pour les surfaces pleines ? */
{
  Station_VDI *station;

  station = quelle_station(handle);
  if (station == NULL)
    return -1;

  return per_vis;
}

#ifdef AVEC_VDI_COMPLETE_
int  vsf_xperimeter    (int handle, int per_vis, int per_style);
void vsf_udpat         (int handle, int *pfill_pat, int planes);
void vs_grayoverride   (int handle, int grayval);
#endif
