/* LASE - Logiciel d'Analyse des Spectres EXAFS
   (c) 1996-2002, Emmanuel CURIS
   Cration              : 10 mai 2002
   Dernire modification : 

   Calcul matriciel, avec gestion de la mmoire optimise
   Extraction d'une sous-matrice
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "systeme.h"
#include "erreurs.h"

#include "matrices.h"

/* ~~~~~~~~ Fonctions locales ~~~~~~~~~~~ */

static Matrice *MAT_ExtraitSymetrique(Matrice *matrice, unsigned int i_deb, unsigned int larg);

/* ~~~~~~~~ Ralisation pratique ~~~~~~~~ */

/* On extrait une matrice symtrique d'une matrice dj symtrique */

static Matrice *MAT_ExtraitSymetrique(Matrice *matrice, unsigned int i_deb, unsigned int larg)
{
  unsigned int i, j;
  Matrice *bloc;

  bloc = creer_matrice(larg, larg, MATRICE_SYMETRIQUE);
  if ( NULL == bloc ) return NULL;

  /* On ne stocke que la partie infrieure, diagonale comprise */
  for (i = 0 ; i < larg ; i++) {
    for (j = 0 ; j <= i ; j++) {

      bloc->valeurs[ MAT_SYM_element(i, j) ] = 
	matrice->valeurs[ MAT_SYM_element(i_deb + i, i_deb + j) ];
    }
  }

  return bloc;
}

Matrice *MAT_ExtraitBloc(Matrice *matrice, unsigned int i_deb, unsigned int j_deb, unsigned int larg, unsigned int haut)
{
  Matrice *bloc = NULL;

  if ( NULL == matrice ) return NULL;

  /* On vrifie que la rgion demande est bien contenue dans la matrice fournie */
  if ( (i_deb > matrice->n_lignes) || (j_deb > matrice->n_colonnes) )
    return NULL;
  if ( i_deb + larg - 1 > matrice->n_lignes ) return NULL;
  if ( j_deb + haut - 1 > matrice->n_colonnes ) return NULL;

  switch ( matrice->type )
  {
  case MATRICE_SYMETRIQUE:
    if ( (i_deb == j_deb) && (larg == haut) )
      bloc = MAT_ExtraitSymetrique(matrice, i_deb, larg);
    else {
    }
    break;
  }

  return bloc;
}
