/* Accents au codage ISO-Latin 8859-1
   (c) Emmanuel CURIS, 20 mars 1998
*/

#ifdef CODAGE_UTF8_
# error "Impossible de coder en mme temps en latin 1 et en UTF-8"
#endif

#ifndef CODAGE_LATIN1_		/* Protection contre l'inclusion multiple */
# define CODAGE_LATIN1_

# ifdef CODAGE__
#  error "Un codage a dj t dfini, double codage impossible"
# endif
# define CODAGE__

/* -------- Accents -------- */

#define ACCENT_AIGU  "\xB4"
#define ACCENT_GRAVE "`"
#define TREMA        "\xA8"

/* -------- Lettres latines accentues -------- */

#define a_AIGU  ""
#define A_AIGU  ""
#define a_CIRC  ""
#define A_CIRC  ""
#define a_GRAVE ""
#define A_GRAVE ""
#define a_ROND  ""
#define A_ROND  ""
#define a_TILDE ""
#define A_TILDE ""
#define a_TREMA ""
#define A_TREMA ""

#define c_AIGU    ACCENT_AIGU"c"
#define C_AIGU    ACCENT_AIGU"C"
#define c_CEDILLE ""
#define C_CEDILLE ""
#define c_CIRC    "^c"
#define C_CIRC    "^C"

#define e_AIGU  ""
#define E_AIGU  ""
#define e_CIRC  ""
#define E_CIRC  ""
#define e_GRAVE ""
#define E_GRAVE ""
#define e_TILDE "~e"
#define E_TILDE "~E"
#define e_TREMA ""
#define E_TREMA ""

#define ESTZET  ""
#define Eth     ""
#define ETH     ""

#define g_AIGU  ACCENT_AIGU"g"
#define G_AIGU  ACCENT_AIGU"G"
#define g_CIRC  "^g"
#define G_CIRC  "^G"

#define h_CIRC  "^h"
#define H_CIRC  "^H"
#define h_TREMA TREMA"h"
#define H_TREMA TREMA"H"

#define i_AIGU  ""
#define I_AIGU  ""
#define i_CIRC  ""
#define I_CIRC  ""
#define i_GRAVE ""
#define I_GRAVE ""
#define i_TILDE "~i"
#define I_TILDE "~I"
#define i_TREMA ""
#define I_TREMA ""

#define j_CIRC  "^j"
#define J_CIRC  "^J"

#define k_AIGU  ACCENT_AIGU"k"
#define K_AIGU  ACCENT_AIGU"K"

#define l_AIGU  ACCENT_AIGU"l"
#define L_AIGU  ACCENT_AIGU"L"

#define LIG_ae      ""
#define LIG_AE      ""
#define LIG_ae_AIGU ACCENT_AIGU""
#define LIG_AE_AIGU ACCENT_AIGU""
#define LIG_ij      "ij"
#define LIG_IJ      "IJ"
#define LIG_oe      "oe"
#define LIG_OE      "OE"

#define m_AIGU  ACCENT_AIGU"m"
#define M_AIGU  ACCENT_AIGU"M"

#define n_AIGU  ACCENT_AIGU"n"
#define N_AIGU  ACCENT_AIGU"N"
#define n_CEDILLE ",n"
#define N_CEDILLE ",N"
#define n_GRAVE   "`n"
#define N_GRAVE   "`N"
#define n_TILDE ""
#define N_TILDE ""
#define n_TREMA   TREMA"n"
#define N_TREMA   TREMA"N"

#define o_AIGU  ""
#define O_AIGU  ""
#define o_BARRE ""
#define O_BARRE ""
#define o_CIRC  ""
#define O_CIRC  ""
#define o_GRAVE ""
#define O_GRAVE ""
#define o_TILDE ""
#define O_TILDE ""
#define o_TREMA ""
#define O_TREMA ""

#define p_AIGU  ACCENT_AIGU"p"
#define P_AIGU  ACCENT_AIGU"P"

#define r_AIGU  ACCENT_AIGU"r"
#define R_AIGU  ACCENT_AIGU"R"

#define s_AIGU  ACCENT_AIGU"s"
#define S_AIGU  ACCENT_AIGU"S"
#define s_CIRC  "^s"
#define S_CIRC  "^S"

#define t_TREMA TREMA"t"
#define T_TREMA TREMA"T"

#define Thorn   ""
#define THORN   ""

#define u_AIGU  ""
#define U_AIGU  ""
#define u_CIRC  ""
#define U_CIRC  ""
#define u_GRAVE ""
#define U_GRAVE ""
#define u_TILDE "u"
#define U_TILDE "U"
#define u_TREMA ""
#define U_TREMA ""

#define w_AIGU  ACCENT_AIGU"w"
#define W_AIGU  ACCENT_AIGU"W"
#define w_CIRC  "^w"
#define W_CIRC  "^W"
#define w_TREMA TREMA"w"
#define W_TREMA TREMA"W"

#define x_TREMA TREMA"x"
#define X_TREMA TREMA"X"

#define y_AIGU  ""
#define Y_AIGU  ""
#define y_CIRC  "^y"
#define Y_CIRC  "^Y"
#define y_GRAVE "`y"
#define Y_GRAVE "`Y"
#define y_TREMA ""
#define Y_TREMA TREMA"Y"

#define z_AIGU  ACCENT_AIGU"z"
#define Z_AIGU  ACCENT_AIGU"Z"
#define z_CIRC  "^z"
#define Z_CIRC  "^Z"

/* -------- Alphabet grec --------------------- */

#define ALPHA   "alpha"
#define BETA    ""
#define DELTA   "delta"
#define EPSILON "epsilon"
#define ETA     "eta"
#define GAMMA   "gamma"
#define IOTA    "iota"
#define KAPPA   "kappa"
#define KHI     "khi"
#define KSI     "ksi"
#define LAMBDA  "lambda"
#define MU      ""
#define NU      "nu"
#define RHO     "rho"
#define OMEGA   "omega"
#define OMICRON "omicron"
#define PI      "pi"
#define PHI     "phi"
#define PSI     "psi"
#define SIGMA   "sigma"
#define TAU     "tau"
#define THETA   "thta"
#define UPSILON "upsilon"
#define ZETA    "zeta"

#define GAMMA_MAJUSCULE "Gamma"
#define DELTA_MAJUSCULE "Delta"
#define OMEGA_MAJUSCULE "Omega"
#define PHI_MAJUSCULE   "Phi"
#define SIGMA_MAJUSCULE "Sigma"

/* -------- Alphabet hébreu -------- */

#define ALEPH "alef"

/* -------- Caractres en exposant ------------ */

#define a_EXPOSANT     ""
#define n_EXPOSANT     "^n"
#define o_EXPOSANT     ""

#define ZERO_EXPOSANT   "^0"
#define UN_EXPOSANT     ""
#define DEUX_EXPOSANT   ""
#define TROIS_EXPOSANT  ""
#define QUATRE_EXPOSANT "^4"
#define CINQ_EXPOSANT   "^5"
#define SIX_EXPOSANT    "^6"
#define SEPT_EXPOSANT   "^7"
#define HUIT_EXPOSANT   "^8"
#define NEUF_EXPOSANT   "^9"
#define EGAL_EXPOSANT   "^="
#define PLUS_EXPOSANT   "^+"
#define MOINS_EXPOSANT  "^-"
#define PARENTHESE_OUVRANTE_EXPOSANT "^("
#define PARENTHESE_FERMANTE_EXPOSANT "^)"

/* -------- Mathmatiques --------------------- */

#define DEGRE       ""
#define DIVISER     ""
#define MULTIPLIER  ""
#define PLUS_MOINS  ""
#define SIGNE_MOINS "-"

#define EQUIVALENT  "=="
#define INFERIEUR_EGAL "<="
#define SUPERIEUR_EGAL ">="

#define INFINI      "Inf"
#define TROIS_QUART ""
#define UN_DEMI     ""
#define UN_QUART    ""

#define ET_LOGIQUE  "ET"

#define APPARTIENT   "dans"
#define INTERSECTION "et"
#define UNION        "ou"

/* -------- Ponctuations tendues ------------- */

#define ESPACE_INSECABLE  ""
#define ESPACE_FINE       " "
#define EXCLAME_INVERSE   ""
#define GUILLEMET_FERMANT ""
#define GUILLEMET_OUVRANT ""
#define INTERROGE_INVERSE ""
#define PARAGRAPHE        ""
#define POINT_MULTIPLIER  ""
#define TIRET_CADRATIN    "---"
#define TIRET_CESURE      ""

/* -------- Symboles de monnaies -------------- */

#define CENT_AMERICAIN ""
#define LIVRE_STERLING ""
#define MONNAIE        ""
#define YEN            ""

/* -------- Symboles divers ------------------- */

#define OBELE      "+"
#define FIN_LIGNE  ""

#define COPYRIGHT  ""
#define ENREGISTRE ""
#define MARQUE_DEPOSEE "^TM"

/* -------- Units de mesure ------------------ */

#define ANGSTROM ""
#define OHM      "ohm"
#define MICRON   ""

#endif	/* CODAGE_LATIN1_ */
