/* Traitement de l'E.X.A.F.S. sur Atari
   Fichier à inclure pour les differentes interfaces et la langue
   (c) 1996 - 2002 - Emmanuel CURIS
*/

#ifndef SYSTEME_H_
#define SYSTEME_H_ /* Protection contre l'inclusion multiple */

#define VERSION 36 /* Numéro de version : 10 = 1.0 */

#if !defined(_TURBO_C_) && !defined(_PURE_C_)
# define cdecl 
/* cdecl est indispensable pour les fonctions des USERDEF avec Turbo C et Pure C,
   sinon on a des redessins hautement farfelus ! */
#endif
#ifndef _gcc_
# define __attribute__(truc) /* Spécifique GCC */
#endif

#ifdef _UNIX_
# define SEPARE_DOSSIERS '/'
#endif

#if defined(_TOS_) || defined(_DOS_) || defined(_WINDOWS_)
# define SEPARE_DOSSIERS '\\'
#endif

#ifdef _MAC_OS_
# define SEPARE_DOSSIERS ':'
#endif

/* -------- Inclusions pour l'interface graphique, suivant le système utilisé -------- */

#ifdef _GEM_
# include "ac_atari.h" /* Accents au format atari */
#endif

#if defined( _UNIX_ ) || defined( _MACOS_X_ )
# ifdef _utf8_
#  include "utf8.h"    /* Codage en UTF-8, par défaut depuis le 26 juillet 2015 */
# endif
# ifdef _latin1_
#  include "latin_1.h" /* Codage latin-1, par défaut jusqu'au 26 juillet 2015 */
# endif
#endif

#ifdef _WINDOWS_
#  include "windows1252.h" /* Codage windows-1252 (latin1 + quelques codes en plus) */
#endif

#include "Bib_Commun/bib_interface.h"

/* Partie commune de la bibliothèque d'interface */
#include "erreurs.h"   /* Codes d'erreur divers */

/* -------- Variables générales pour LASE -------- */

#ifndef VARIABLES_GENERALES_ /* Déclarées dans variables.c */
extern Fenetre *principale;    /* Fenêtre principale... */
extern Fenetre *trace_fenetre; /* Fenêtre de superposition */
#endif

#define FEN_INFOS_GRAPHE FEN_COMPLEMENT_1 /* Si un graphe est associé à la fenêtre, c'est dans le 1er champ utilisateur ! */

/* -------- Tout ce qui concerne l'historique des opérations -------- */

#include "historique.h"

void HIST_OptionChoisie(unsigned int niveau, const char *preambule,
			unsigned int nbr_options, unsigned int option_choisie, const char *options[]);
void HIST_ResultatTestStatistique(const char *nom_test, const char *H0, const char *H1,
				  double val_observee, double val_theorie, double val_H0,
				  double variance_H0, double proba_rejet_H0, boolean exact, const char *condition,...);

/* -------- Tout ce qui concerne le déboguage, commun à tous les modules, forcément... -------- */

#ifdef _DEVELOPPE_  /* Pas de log si on n'est pas en développement ! */
# define  DEBOGUE_MALLOC_ 1 /* Log de la mémoire */
# include "deboguage.h"
#else
# define ENTREE_FONCTION(nom, params, ...) /* Inutile */
# define DANS_FONCTION(nom, ...)            /* Inutile */
# define SORTIE_FONCTION(nom, renvoi, ...) /* Inutile */
#endif

#endif /* SYSTEME_H_ */
